#!/bin/sh
# Copie du fichier wifi_setup.sh pour un mode recovery en cas de pb reseau
#cp /bin/wifi_setup.sh.orig /bin/wifi_setup.sh

export LD_PRELOAD=/data/libioctl_arm.so

UPDATE_PATH=/update/ardrone_update.plf
VERSION_PATH=/update/version.txt
ERR_PATH=/update/err.log

echo "Copy version.txt file in ftp directory"
cp /firmware/version.txt $VERSION_PATH

echo "Check if update is necessary ..."
if [ -e $UPDATE_PATH ] ; then
	VERSION=`cat $VERSION_PATH`
	
	if [ -e $ERR_PATH ] ; then
		CHECK_ERR=`cat $ERR_PATH`
		if [ "$CHECK_ERR" = "NEED_TO_FLASH" ] ; then
			CHECK_PLF=`/bin/checkplf $UPDATE_PATH $VERSION`
			if [ "$CHECK_PLF" = "NEED_TO_FLASH" ] ; then
				echo "ERR=FLASH_KO" > $ERR_PATH
			else
				/bin/checkplf $UPDATE_PATH $VERSION > $ERR_PATH	
			fi
		else
			/bin/checkplf $UPDATE_PATH $VERSION > $ERR_PATH	
		fi
	else
		/bin/checkplf $UPDATE_PATH $VERSION > $ERR_PATH
	fi
	
	CHECK_ERR=`cat $ERR_PATH`
	if [ "$CHECK_ERR" = "NEED_TO_FLASH" ] ; then 
    	echo "File $UPDATE_PATH exists... Start updating..."
 		pinst_trigger
		echo "Rebooting..."
    	reboot
    else
    	if [ "$CHECK_ERR" = "VERSION_OK" ] ; then
 	    	echo "Version OK"
    	elif [ "$CHECK_ERR" = "ERR=FLASH_KO" ] ; then
 	    	echo "Error during Updating... Removing..."
    	else
 	    	echo "File $UPDATE_PATH not valid... Removing..."
    	fi
    	rm -Rf $UPDATE_PATH
		echo "Start Drone software..."
		inetd
	    (/bin/program.elf ; gpio 63 -d ho 1) &
	fi
else
    echo "File $UPDATE_PATH doesn't exists... Start Drone software..."
    if [ -e $ERR_PATH ] ; then
    	rm -Rf $ERR_PATH
    fi
    inetd
    (/bin/program.elf ; gpio 63 -d ho 1) &
fi
